<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=iso-8859-1">
<title>discover: /home/pere/src/debiancvs/pkg-discover/discover/trunk/lib/conf.c Source File</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.4.2 -->
<div class="qindex"><a class="qindex" href="index.html">Main&nbsp;Page</a> | <a class="qindex" href="modules.html">Modules</a> | <a class="qindex" href="annotated.html">Data&nbsp;Structures</a> | <a class="qindex" href="dirs.html">Directories</a> | <a class="qindex" href="files.html">File&nbsp;List</a> | <a class="qindex" href="functions.html">Data&nbsp;Fields</a> | <a class="qindex" href="globals.html">Globals</a></div>
<div class="nav">
<a class="el" href="dir_000002.html">lib</a></div>
<h1>conf.c</h1><a href="conf_8c.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment">00001 
00012 <span class="comment">/* $Progeny$</span>
00013 <span class="comment"> *</span>
00014 <span class="comment"> * Copyright 2002-2005 Progeny Linux Systems, Inc.</span>
00015 <span class="comment"> * Copyright 2002 Hewlett-Packard Company</span>
00016 <span class="comment"> *</span>
00017 <span class="comment"> * Permission is hereby granted, free of charge, to any person obtaining a</span>
00018 <span class="comment"> * copy of this software and associated documentation files (the "Software"),</span>
00019 <span class="comment"> * to deal in the Software without restriction, including without limitation</span>
00020 <span class="comment"> * the rights to use, copy, modify, merge, publish, distribute, sublicense,</span>
00021 <span class="comment"> * and/or sell copies of the Software, and to permit persons to whom the</span>
00022 <span class="comment"> * Software is furnished to do so, subject to the following conditions:</span>
00023 <span class="comment"> *</span>
00024 <span class="comment"> * The above copyright notice and this permission notice shall be included in</span>
00025 <span class="comment"> * all copies or substantial portions of the Software.</span>
00026 <span class="comment"> *</span>
00027 <span class="comment"> * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span>
00028 <span class="comment"> * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span>
00029 <span class="comment"> * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL</span>
00030 <span class="comment"> * THE COPYRIGHT HOLDER(S) BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span>
00031 <span class="comment"> * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING</span>
00032 <span class="comment"> * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER</span>
00033 <span class="comment"> * DEALINGS IN THE SOFTWARE.</span>
00034 <span class="comment"> */</span>
00035 
00036 <span class="preprocessor">#include "config.h"</span>
00037 
00038 <span class="preprocessor">#if HAVE_DIRENT_H</span>
00039 <span class="preprocessor"></span><span class="preprocessor">#include &lt;dirent.h&gt;</span>
00040 <span class="preprocessor">#define NAMLEN(d) strlen((d)-&gt;d_name)</span>
00041 <span class="preprocessor"></span><span class="preprocessor">#else</span>
00042 <span class="preprocessor"></span><span class="preprocessor">#define dirent direct</span>
00043 <span class="preprocessor"></span><span class="preprocessor">#define NAMLEN(d) (d)-&gt;d_namlen</span>
00044 <span class="preprocessor"></span><span class="preprocessor">#if HAVE_SYS_NDIR_H</span>
00045 <span class="preprocessor"></span><span class="preprocessor">#include &lt;sys/ndir.h&gt;</span>
00046 <span class="preprocessor">#endif</span>
00047 <span class="preprocessor"></span><span class="preprocessor">#if HAVE_SYS_DIR_H</span>
00048 <span class="preprocessor"></span><span class="preprocessor">#include &lt;sys/dir.h&gt;</span>
00049 <span class="preprocessor">#endif</span>
00050 <span class="preprocessor"></span><span class="preprocessor">#if HAVE_NDIR_H</span>
00051 <span class="preprocessor"></span><span class="preprocessor">#include &lt;ndir.h&gt;</span>
00052 <span class="preprocessor">#endif</span>
00053 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
00054 <span class="preprocessor"></span>
00055 <span class="preprocessor">#include &lt;assert.h&gt;</span>
00056 <span class="preprocessor">#include &lt;string.h&gt;</span>
00057 
00058 <span class="preprocessor">#include &lt;expat.h&gt;</span>
00059 
00060 <span class="preprocessor">#include &lt;<a class="code" href="discover_8h.html">discover/discover.h</a>&gt;</span>
00061 <span class="preprocessor">#include &lt;<a class="code" href="discover-conf_8h.html">discover/discover-conf.h</a>&gt;</span>
00062 <span class="preprocessor">#include &lt;<a class="code" href="discover-xml_8h.html">discover/discover-xml.h</a>&gt;</span>
00063 
00064 <span class="preprocessor">#include &lt;discover/load-url.h&gt;</span>
00065 <span class="preprocessor">#include &lt;discover/url-xml.h&gt;</span>
00066 <span class="preprocessor">#include &lt;discover/utils.h&gt;</span>
00067 
00068 <span class="comment">/*Busmaps we understand</span>
00069 <span class="comment"> */</span>
00070 <span class="keyword">static</span> <a class="code" href="structdiscover__bus__map.html">discover_bus_map_t</a> bus_map[] = {
00071     { <span class="stringliteral">"ata"</span>, 0, 0, NULL },
00072     { <span class="stringliteral">"pci"</span>, 0, 0, NULL },
00073     { <span class="stringliteral">"pcmcia"</span>, 0, 0, NULL },
00074     { <span class="stringliteral">"scsi"</span>, 0, 0, NULL },
00075     { <span class="stringliteral">"usb"</span>, 0, 0, NULL },
00076     { NULL }
00077 };
00078 
00079 <span class="keyword">static</span> <span class="keywordtype">char</span> * filetype_map[] = {
00080     <span class="stringliteral">"vendor"</span>, <span class="stringliteral">"busclass"</span>, <span class="stringliteral">"device"</span>
00081 };
00082 
00083 <span class="keyword">static</span> <span class="keywordtype">int</span> conf_loaded = 0;
00084 
00085 <span class="keyword">static</span> <a class="code" href="group__types.html#ga7">discover_xml_url_t</a> *pre_urls = NULL;
00086 <span class="keyword">static</span> <a class="code" href="group__types.html#ga7">discover_xml_url_t</a> *post_urls = NULL;
00087 <span class="keyword">static</span> <a class="code" href="group__types.html#ga7">discover_xml_url_t</a> *urls = NULL;
00088 
<a name="l00090"></a><a class="code" href="conf_8c.html#a33">00090</a> <span class="keyword">enum</span> <a class="code" href="conf_8c.html#a33">state</a> { START, BUSSCAN, DATA_SOURCES };
00091 
<a name="l00093"></a><a class="code" href="conf_8c.html#a34">00093</a> <span class="keyword">enum</span> <a class="code" href="conf_8c.html#a34">scan_flag</a> { SCAN_NEVER, SCAN_DEFAULT };
00094 
00095 <span class="keyword">struct </span>context {
00096     <span class="keyword">enum</span> <a class="code" href="conf_8c.html#a33">state</a> <a class="code" href="conf_8c.html#a33">state</a>;
00097     <span class="keyword">enum</span> <a class="code" href="conf_8c.html#a34">scan_flag</a> scan;
00098     <a class="code" href="structdiscover__error.html">discover_error_t</a> *status;
00099 
00100     <span class="keywordtype">int</span> unknown_level; 
00101 };
00102 
00103 <span class="keyword">static</span> <span class="keywordtype">char</span> *known_conf_elements[] = {
00104     <span class="stringliteral">"bus"</span>,
00105     <span class="stringliteral">"data-source"</span>,
00106     <span class="stringliteral">"busscan"</span>,
00107     <span class="stringliteral">"data-sources"</span>,
00108     <span class="stringliteral">"conffile"</span>,
00109     NULL
00110 };
00111 
00112 
00113 <span class="keyword">static</span> <span class="keywordtype">bool</span>
00114 unknown_conf_element(<span class="keyword">const</span> XML_Char * <span class="keyword">const</span> tag)
00115 {
00116     <span class="keywordtype">int</span> i;
00117     <span class="keywordflow">for</span> (i = 0; known_conf_elements[i] != NULL; i++) {
00118         <span class="keywordflow">if</span> (strcmp(tag, known_conf_elements[i]) == 0)
00119             <span class="keywordflow">return</span> <span class="keyword">false</span>;
00120     }
00121     <span class="keywordflow">return</span> <span class="keyword">true</span>;
00122 }
00123 
00124 <span class="keyword">static</span> <span class="keyword">enum</span> <a class="code" href="conf_8c.html#a34">scan_flag</a>
00125 get_scan_flag(<span class="keyword">const</span> XML_Char *attrs[])
00126 {
00127     <span class="keywordtype">int</span> i;
00128     <span class="keywordtype">char</span> *scan;
00129 
00130     assert(attrs != NULL);
00131 
00132     scan = NULL;
00133     <span class="keywordflow">for</span> (i = 0; attrs[i]; i+= 2) {
00134         <span class="keywordflow">if</span> (strcmp(attrs[i], <span class="stringliteral">"scan"</span>) == 0) {
00135             scan = (<span class="keywordtype">char</span> *)attrs[i + 1];
00136         }
00137     }
00138 
00139     assert(scan != NULL);
00140 
00141     <span class="keywordflow">if</span> (strcmp(scan, <span class="stringliteral">"default"</span>) == 0) {
00142         <span class="keywordflow">return</span> SCAN_DEFAULT;
00143     } <span class="keywordflow">else</span> {
00144         <span class="keywordflow">return</span> SCAN_NEVER;
00145     }
00146 }
00147 
00153 <a class="code" href="structdiscover__bus__map.html">discover_bus_map_t</a> *
<a name="l00154"></a><a class="code" href="conf_8c.html#a16">00154</a> <a class="code" href="conf_8c.html#a16">_real_discover_conf_get_bus_map</a>(<a class="code" href="group__types.html#ga16">discover_bus_t</a> bus, <a class="code" href="structdiscover__error.html">discover_error_t</a> *status)
00155 {
00156     assert(status != NULL);
00157     assert(bus &gt;= 0);
00158 
00159     <span class="keywordflow">if</span> (bus &gt;= <a class="code" href="group__types.html#ga14">BUS_COUNT</a>) {
00160         status-&gt;<a class="code" href="structdiscover__error.html#o0">code</a> = <a class="code" href="group__types.html#gga15a20">DISCOVER_EBUSNOTFOUND</a>;
00161     }
00162 
00163     <span class="keywordflow">return</span> (<a class="code" href="structdiscover__bus__map.html">discover_bus_map_t</a> *)(bus_map + bus);
00164 }
00165 
00167 <a class="code" href="structdiscover__bus__map.html">discover_bus_map_t</a> *
<a name="l00168"></a><a class="code" href="conf_8c.html#a17">00168</a> <a class="code" href="conf_8c.html#a17">_real_discover_conf_get_bus_map_by_name</a>(<span class="keywordtype">char</span> *name, <a class="code" href="structdiscover__error.html">discover_error_t</a> *status)
00169 {
00170     <a class="code" href="group__types.html#ga16">discover_bus_t</a> bus;
00171 
00172     assert(status != NULL);
00173 
00174     bus = <a class="code" href="group__conf.html#ga1">discover_conf_name_to_bus</a>(name, status);
00175 
00176     <span class="keywordflow">if</span> (status-&gt;<a class="code" href="structdiscover__error.html#o0">code</a> != 0) {
00177         <span class="keywordflow">return</span> NULL;
00178     }
00179 
00180     <span class="keywordflow">return</span> <a class="code" href="conf_8c.html#a16">_real_discover_conf_get_bus_map</a>(bus, status);
00181 }
00182 
00183 <span class="keyword">static</span> <span class="keywordtype">void</span>
00184 _real_discover_conf_insert_url(<span class="keywordtype">char</span> *url, <a class="code" href="structdiscover__error.html">discover_error_t</a> *status)
00185 {
00186     <a class="code" href="group__types.html#ga7">discover_xml_url_t</a> *<span class="keyword">new</span>;
00187 
00188     assert(url != NULL);
00189     assert(status != NULL);
00190 
00191     status-&gt;<a class="code" href="structdiscover__error.html#o0">code</a> = 0;
00192 
00193     <span class="keyword">new</span> = <a class="code" href="group__url__xml.html#ga4">discover_xml_url_new</a>();
00194     <span class="keyword">new</span>-&gt;url = _discover_xstrdup(url);
00195 
00196     <span class="keyword">new</span>-&gt;next = pre_urls;
00197     <span class="keywordflow">if</span> (pre_urls) {
00198         <span class="keywordflow">if</span> (pre_urls-&gt;last) {
00199             <span class="keyword">new</span>-&gt;last = pre_urls-&gt;last;
00200         } <span class="keywordflow">else</span> {
00201             <span class="keyword">new</span>-&gt;last = pre_urls;
00202         }
00203     } <span class="keywordflow">else</span> {
00204         <span class="keyword">new</span>-&gt;last = NULL;
00205     }
00206 
00207     pre_urls = <span class="keyword">new</span>;
00208 }
00209 
00210 <span class="keyword">static</span> <span class="keywordtype">void</span>
00211 _real_discover_conf_append_url(<span class="keywordtype">char</span> *url, <a class="code" href="structdiscover__error.html">discover_error_t</a> *status)
00212 {
00213     <a class="code" href="group__types.html#ga7">discover_xml_url_t</a> *<span class="keyword">new</span>;
00214 
00215     assert(url != NULL);
00216     assert(status != NULL);
00217 
00218     status-&gt;<a class="code" href="structdiscover__error.html#o0">code</a> = 0;
00219 
00220     <span class="keyword">new</span> = <a class="code" href="group__url__xml.html#ga4">discover_xml_url_new</a>();
00221     <span class="keyword">new</span>-&gt;url = _discover_xstrdup(url);
00222 
00223     <span class="keywordflow">if</span> (post_urls) {
00224         <span class="keywordflow">if</span> (post_urls-&gt;last) {
00225             post_urls-&gt;last-&gt;next = <span class="keyword">new</span>;
00226         } <span class="keywordflow">else</span> {
00227             post_urls-&gt;next = <span class="keyword">new</span>;
00228         }
00229         post_urls-&gt;last = <span class="keyword">new</span>;
00230     } <span class="keywordflow">else</span> {
00231         post_urls = <span class="keyword">new</span>;
00232         post_urls-&gt;next = NULL;
00233         post_urls-&gt;last = NULL;
00234     }
00235 }
00236 
00237 <span class="keyword">static</span> <span class="keywordtype">void</span>
00238 start_element(<span class="keywordtype">void</span> *ctx, <span class="keyword">const</span> XML_Char *name, <span class="keyword">const</span> XML_Char *attrs[])
00239 {
00240     <span class="keyword">struct </span>context *context = ctx;
00241     <a class="code" href="structdiscover__bus__map.html">discover_bus_map_t</a> *busmap;
00242     <a class="code" href="structdiscover__error.html">discover_error_t</a> *status;
00243     <span class="keywordtype">char</span> *busname;
00244     <span class="keywordtype">char</span> *found_url;
00245     <span class="keywordtype">int</span> prepend_url;
00246     <span class="keywordtype">int</span> i;
00247 
00248     assert(context != NULL);
00249     assert(name != NULL);
00250 
00251     <span class="keywordflow">if</span> (unknown_conf_element(name)) {
00252         context-&gt;unknown_level++;
00253         <span class="keywordflow">return</span>;
00254     }
00255 
00256     <span class="keywordflow">if</span> (context-&gt;unknown_level &gt; 0) {
00257         <span class="keywordflow">return</span>;
00258     }
00259 
00260     status = context-&gt;status;
00261 
00262     <span class="keywordflow">switch</span> (context-&gt;state) {
00263     <span class="keywordflow">case</span> START:
00264         <span class="keywordflow">if</span> (strcmp(name, <span class="stringliteral">"busscan"</span>) == 0) {
00265             context-&gt;state = BUSSCAN;
00266             context-&gt;scan = get_scan_flag(attrs);
00267         } <span class="keywordflow">else</span> <span class="keywordflow">if</span> (strcmp(name, <span class="stringliteral">"data-sources"</span>) == 0) {
00268             context-&gt;state = DATA_SOURCES;
00269         }
00270         <span class="keywordflow">break</span>;
00271 
00272     <span class="keywordflow">case</span> BUSSCAN:
00273         <span class="keywordflow">if</span> (strcmp(name, <span class="stringliteral">"bus"</span>) == 0) {
00274             assert(attrs != NULL);
00275 
00276             <span class="keywordflow">for</span> (i = 0; attrs[i]; i += 2) {
00277                 <span class="keywordflow">if</span> (strcmp(attrs[i], <span class="stringliteral">"name"</span>) == 0) {
00278                     busname = (<span class="keywordtype">char</span> *)attrs[i + 1];
00279                     busmap = <a class="code" href="conf_8c.html#a17">_real_discover_conf_get_bus_map_by_name</a>(busname, status);
00280                     <span class="keywordflow">if</span> (status-&gt;<a class="code" href="structdiscover__error.html#o0">code</a> != 0) {
00281                         <span class="keywordflow">return</span>;
00282                     }
00283                     <span class="keywordflow">if</span> (context-&gt;scan == SCAN_DEFAULT) {
00284                         busmap-&gt;<a class="code" href="structdiscover__bus__map.html#o1">scan_default</a> = 1;
00285                     } <span class="keywordflow">else</span> {
00286                         busmap-&gt;<a class="code" href="structdiscover__bus__map.html#o2">scan_never</a> = 1;
00287                     }
00288                 }
00289             }
00290         }
00291         <span class="keywordflow">break</span>;
00292 
00293     <span class="keywordflow">case</span> DATA_SOURCES:
00294         <span class="keywordflow">if</span> (strcmp(name, <span class="stringliteral">"data-source"</span>) == 0) {
00295             found_url = NULL;
00296             prepend_url = 0;
00297             <span class="keywordflow">for</span> (i = 0; attrs[i]; i += 2) {
00298                 <span class="keywordflow">if</span> (strcmp(attrs[i], <span class="stringliteral">"url"</span>) == 0) {
00299                     found_url = (<span class="keywordtype">char</span> *)attrs[i + 1];
00300                 }
00301                 <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((strcmp(attrs[i], <span class="stringliteral">"place"</span>) == 0) &amp;&amp;
00302                          (strcmp(attrs[i + 1], <span class="stringliteral">"before"</span>) == 0)) {
00303                     prepend_url = 1;
00304                 }
00305             }
00306             <span class="keywordflow">if</span> (found_url != NULL) {
00307                 <span class="keywordflow">if</span> (prepend_url != 0) {
00308                     _real_discover_conf_insert_url(found_url, status);
00309                 } <span class="keywordflow">else</span> {
00310                     _real_discover_conf_append_url(found_url, status);
00311                 }
00312                 <span class="keywordflow">if</span> (status-&gt;<a class="code" href="structdiscover__error.html#o0">code</a> != 0) {
00313                     <span class="keywordflow">return</span>;
00314                 }
00315             }
00316         }
00317         <span class="keywordflow">break</span>;
00318     }
00319 }
00320 
00321 <span class="keyword">static</span> <span class="keywordtype">void</span>
00322 end_element(<span class="keywordtype">void</span> *ctx, <span class="keyword">const</span> XML_Char *name)
00323 {
00324     <span class="keyword">struct </span>context *context = ctx;
00325 
00326     assert(context != NULL);
00327     assert(name != NULL);
00328 
00329     <span class="keywordflow">if</span> (unknown_conf_element(name)) {
00330         context-&gt;unknown_level--;
00331         <span class="keywordflow">return</span>;
00332     }
00333 
00334     <span class="keywordflow">if</span> (context-&gt;unknown_level &gt; 0) {
00335         <span class="keywordflow">return</span>;
00336     }
00337 
00338     <span class="keywordflow">switch</span> (context-&gt;state) {
00339     <span class="keywordflow">case</span> START:
00340     <span class="keywordflow">break</span>;
00341 
00342     <span class="keywordflow">case</span> BUSSCAN:
00343         <span class="keywordflow">if</span> (strcmp(name, <span class="stringliteral">"busscan"</span>) == 0) {
00344             context-&gt;state = START;
00345         }
00346     <span class="keywordflow">break</span>;
00347 
00348     <span class="keywordflow">case</span> DATA_SOURCES:
00349         <span class="keywordflow">if</span> (strcmp(name, <span class="stringliteral">"data-sources"</span>) == 0) {
00350             context-&gt;state = START;
00351         }
00352     <span class="keywordflow">break</span>;
00353     }
00354 }
00355 
00377 <span class="keywordtype">void</span>
<a name="l00378"></a><a class="code" href="group__conf.html#ga0">00378</a> <a class="code" href="group__conf.html#ga0">discover_conf_load</a>(<a class="code" href="structdiscover__error.html">discover_error_t</a> *status)
00379 {
00380     XML_Parser parser;
00381     <span class="keyword">struct </span>context context;
00382     <span class="keywordtype">int</span> load_url_status;
00383     <span class="keywordtype">int</span> conf_load_error = 0;
00384     <span class="keywordtype">int</span> conf_parse_error = 0;
00385     DIR *confdir;
00386     <span class="keyword">struct </span>dirent *confent;
00387     <span class="keywordtype">char</span> buf[512];
00388 
00389     assert(status != NULL);
00390 
00391     status-&gt;<a class="code" href="structdiscover__error.html#o0">code</a> = 0;
00392 
00393     <span class="keywordflow">if</span> (conf_loaded) {
00394         <span class="keywordflow">return</span>;
00395     }
00396 
00397     confdir = opendir(SYSCONFDIR <span class="stringliteral">"/discover.conf.d"</span>);
00398     <span class="keywordflow">if</span> (confdir != NULL) {
00399         <span class="keywordflow">while</span> ((confent = readdir(confdir)) != NULL) {
00400             <span class="keywordflow">if</span> (strchr(confent-&gt;d_name, <span class="charliteral">'.'</span>) != NULL) {
00401                 <span class="keywordflow">continue</span>;
00402             }
00403 
00404             context.state = START;
00405             context.status = status;
00406             context.unknown_level = 0;
00407 
00408             parser = XML_ParserCreate(NULL);
00409             XML_SetElementHandler(parser, start_element, end_element);
00410             XML_SetUserData(parser, &amp;context);
00411 
00412             strcpy(buf, <span class="stringliteral">"file:///"</span> SYSCONFDIR <span class="stringliteral">"/discover.conf.d/"</span>);
00413             strncat(buf, confent-&gt;d_name, <span class="keyword">sizeof</span>(buf));
00414             buf[<span class="keyword">sizeof</span>(buf) - 1] = <span class="charliteral">'\0'</span>;
00415 
00416             load_url_status = _discover_load_url(buf, parser);
00417 
00418             <span class="comment">/* start_element may change status. */</span>
00419             <span class="keywordflow">if</span> (status-&gt;<a class="code" href="structdiscover__error.html#o0">code</a> != 0) {
00420                 <span class="keywordtype">char</span> *message = _discover_xmalloc(256);
00421                 snprintf(message, 256, <span class="stringliteral">"Error parsing configuration file %s"</span>, 
00422                          buf);
00423                 status-&gt;<a class="code" href="structdiscover__error.html#o2">create_message</a>(&amp;status, message);
00424                 XML_ParserFree(parser);
00425                 conf_parse_error = 1;
00426                 <span class="keywordflow">break</span>;
00427             }
00428 
00429             <span class="comment">/* Ignore URL load errors; the conf file is not mandatory. */</span>
00430             <span class="keywordflow">if</span> (!load_url_status) {
00431                 conf_load_error = 1;
00432                 XML_ParserFree(parser);
00433                 <span class="keywordflow">continue</span>;
00434             }
00435 
00436             <span class="keywordflow">if</span> (!XML_Parse(parser, <span class="stringliteral">""</span>, 0, 1)) {
00437                 <span class="keywordtype">char</span> *message = _discover_xmalloc(256);
00438                 snprintf(message, 256, <span class="stringliteral">"Error parsing configuration file %s"</span>, 
00439                          buf);
00440                 status-&gt;<a class="code" href="structdiscover__error.html#o2">create_message</a>(&amp;status, message);
00441                 status-&gt;<a class="code" href="structdiscover__error.html#o0">code</a> = <a class="code" href="group__types.html#gga15a17">DISCOVER_EXML</a>;
00442                 XML_ParserFree(parser);
00443                 conf_parse_error = 1;
00444                 <span class="keywordflow">break</span>;
00445             }
00446 
00447 
00448             XML_ParserFree(parser);
00449         }
00450 
00451         closedir(confdir);
00452 
00453         <span class="keywordflow">if</span> (conf_parse_error) {
00454             <span class="keywordflow">return</span>;
00455         }
00456     }
00457 
00458     <span class="keywordflow">if</span> (conf_load_error) {
00459         <span class="keywordtype">char</span> *message = _discover_xmalloc(256);
00460         snprintf(message, 256, 
00461                  <span class="stringliteral">"Failed loading one or more configuration files"</span>);
00462         status-&gt;<a class="code" href="structdiscover__error.html#o2">create_message</a>(&amp;status, message);
00463     }
00464 
00465     conf_loaded = 1;
00466 
00467     <span class="keywordflow">return</span>;
00468 }
00469 
00476 <span class="keywordtype">int</span>
<a name="l00477"></a><a class="code" href="group__conf.html#ga1">00477</a> <a class="code" href="group__conf.html#ga1">discover_conf_name_to_bus</a>(<span class="keywordtype">char</span> *name, <a class="code" href="structdiscover__error.html">discover_error_t</a> *status)
00478 {
00479     <span class="keywordtype">int</span> i;
00480     <span class="keywordflow">for</span> (i = 0; bus_map[i].name; i++) {
00481         <span class="keywordflow">if</span> (strcmp(bus_map[i].name, name) == 0) {
00482             <span class="keywordflow">return</span> i;
00483         }
00484     }
00485 
00486     status-&gt;<a class="code" href="structdiscover__error.html#o0">code</a> = <a class="code" href="group__types.html#gga15a20">DISCOVER_EBUSNOTFOUND</a>;
00487     <span class="keywordflow">return</span> -1;
00488 }
00489 
00495 <a class="code" href="structdiscover__bus__map.html">discover_bus_map_t</a> *
<a name="l00496"></a><a class="code" href="group__conf.html#ga2">00496</a> <a class="code" href="group__conf.html#ga2">discover_conf_get_full_bus_map</a>(<a class="code" href="structdiscover__error.html">discover_error_t</a> *status)
00497 {
00498     <a class="code" href="group__conf.html#ga0">discover_conf_load</a>(status);
00499     <span class="keywordflow">return</span> bus_map;
00500 }
00501 
00508 <a class="code" href="structdiscover__bus__map.html">discover_bus_map_t</a> *
<a name="l00509"></a><a class="code" href="group__conf.html#ga3">00509</a> <a class="code" href="group__conf.html#ga3">discover_conf_get_bus_map_by_name</a>(<span class="keywordtype">char</span> *name, <a class="code" href="structdiscover__error.html">discover_error_t</a> *status)
00510 {
00511     assert(status != NULL);
00512 
00513     <a class="code" href="group__conf.html#ga0">discover_conf_load</a>(status);
00514     <span class="keywordflow">if</span> (status-&gt;<a class="code" href="structdiscover__error.html#o0">code</a> != 0) {
00515         <span class="keywordflow">return</span> NULL;
00516     }
00517 
00518     <span class="comment">/*</span>
00519 <span class="comment">     * The "real" one won't call conf_load(), which will be useful</span>
00520 <span class="comment">     * elsewhere.</span>
00521 <span class="comment">     */</span>
00522     <span class="keywordflow">return</span> <a class="code" href="conf_8c.html#a17">_real_discover_conf_get_bus_map_by_name</a>(name, status);
00523 }
00524 
00531 <a class="code" href="structdiscover__bus__map.html">discover_bus_map_t</a> *
<a name="l00532"></a><a class="code" href="group__conf.html#ga4">00532</a> <a class="code" href="group__conf.html#ga4">discover_conf_get_bus_map</a>(<a class="code" href="group__types.html#ga16">discover_bus_t</a> bus, <a class="code" href="structdiscover__error.html">discover_error_t</a> *status)
00533 {
00534     assert(status != NULL);
00535     assert(bus &gt;= 0);
00536 
00537     <span class="keywordflow">if</span> (bus &gt;= <a class="code" href="group__types.html#ga14">BUS_COUNT</a>) {
00538         status-&gt;<a class="code" href="structdiscover__error.html#o0">code</a> = <a class="code" href="group__types.html#gga15a20">DISCOVER_EBUSNOTFOUND</a>;
00539     }
00540 
00541     <a class="code" href="group__conf.html#ga0">discover_conf_load</a>(status);
00542     <span class="keywordflow">if</span> (status-&gt;code != 0) {
00543         <span class="keywordflow">return</span> NULL;
00544     }
00545 
00546     <span class="keywordflow">return</span> (<a class="code" href="structdiscover__bus__map.html">discover_bus_map_t</a> *)(bus_map + bus);
00547 }
00548 
00556 <span class="keywordtype">void</span>
<a name="l00557"></a><a class="code" href="group__conf.html#ga5">00557</a> <a class="code" href="group__conf.html#ga5">discover_conf_insert_url</a>(<span class="keywordtype">char</span> *url, <a class="code" href="structdiscover__error.html">discover_error_t</a> *status)
00558 {
00559     assert(status != NULL);
00560 
00561     <a class="code" href="group__conf.html#ga0">discover_conf_load</a>(status);
00562     <span class="keywordflow">if</span> (status-&gt;<a class="code" href="structdiscover__error.html#o0">code</a> != 0) {
00563         <span class="keywordflow">return</span>;
00564     }
00565 
00566     _real_discover_conf_insert_url(url, status);
00567 
00568     <span class="keywordflow">return</span>;
00569 }
00570 
00578 <span class="keywordtype">void</span>
<a name="l00579"></a><a class="code" href="group__conf.html#ga6">00579</a> <a class="code" href="group__conf.html#ga6">discover_conf_append_url</a>(<span class="keywordtype">char</span> *url, <a class="code" href="structdiscover__error.html">discover_error_t</a> *status)
00580 {
00581     assert(status != NULL);
00582 
00583     <a class="code" href="group__conf.html#ga0">discover_conf_load</a>(status);
00584     <span class="keywordflow">if</span> (status-&gt;<a class="code" href="structdiscover__error.html#o0">code</a> != 0) {
00585         <span class="keywordflow">return</span>;
00586     }
00587 
00588     _real_discover_conf_append_url(url, status);
00589 
00590     <span class="keywordflow">return</span>;
00591 }
00592 
00598 <a class="code" href="group__types.html#ga7">discover_xml_url_t</a> *
<a name="l00599"></a><a class="code" href="group__conf.html#ga7">00599</a> <a class="code" href="group__conf.html#ga7">discover_conf_get_urls</a>(<a class="code" href="structdiscover__error.html">discover_error_t</a> *status)
00600 {
00601     <a class="code" href="group__types.html#ga7">discover_xml_url_t</a> *<span class="keyword">new</span>;
00602 
00603     assert(status != NULL);
00604 
00605     status-&gt;<a class="code" href="structdiscover__error.html#o0">code</a> = 0;
00606 
00607     <span class="keywordflow">if</span> (!urls) {
00608         <a class="code" href="group__conf.html#ga0">discover_conf_load</a>(status);
00609 
00610         <span class="keyword">new</span> = <a class="code" href="group__url__xml.html#ga4">discover_xml_url_new</a>();
00611         <span class="keyword">new</span>-&gt;url = _discover_xstrdup(DISCOVER_DEFAULT_URL);
00612 
00613         <span class="keywordflow">if</span> (pre_urls) {
00614             urls = pre_urls;
00615             <span class="keywordflow">if</span> (urls-&gt;last) {
00616                 urls-&gt;last-&gt;next = <span class="keyword">new</span>;
00617             } <span class="keywordflow">else</span> {
00618                 urls-&gt;next = <span class="keyword">new</span>;
00619             }
00620             urls-&gt;last = <span class="keyword">new</span>;
00621         } <span class="keywordflow">else</span> {
00622             urls = <span class="keyword">new</span>;
00623         }
00624 
00625         <span class="keywordflow">if</span> (post_urls) {
00626             <span class="keywordflow">if</span> (urls-&gt;last) {
00627                 urls-&gt;last-&gt;next = post_urls;
00628             } <span class="keywordflow">else</span> {
00629                 urls-&gt;next = post_urls;
00630             }
00631 
00632             <span class="keywordflow">if</span> (post_urls-&gt;last) {
00633                 urls-&gt;last = post_urls-&gt;last;
00634             } <span class="keywordflow">else</span> {
00635                 urls-&gt;last = post_urls;
00636             }
00637         }
00638 
00639         post_urls = pre_urls = NULL;
00640     }
00641 
00642     <span class="keywordflow">return</span> urls;
00643 }
00644 
00649 <span class="keywordtype">void</span>
<a name="l00650"></a><a class="code" href="group__conf.html#ga8">00650</a> <a class="code" href="group__conf.html#ga8">discover_conf_free</a>(<span class="keywordtype">void</span>)
00651 {
00652     conf_loaded = 0;
00653 
00654     <span class="keywordflow">if</span> (urls) {
00655         <a class="code" href="group__url__xml.html#ga12">discover_xml_url_free</a>(urls);
00656         urls = NULL;
00657     }
00658 }
00659 
00665 <span class="keywordtype">char</span> *
<a name="l00666"></a><a class="code" href="group__conf.html#ga9">00666</a> <a class="code" href="group__conf.html#ga9">discover_conf_get_bus_name</a>(<a class="code" href="group__types.html#ga16">discover_bus_t</a> bus)
00667 {
00668     assert(bus &gt;= 0);
00669     <span class="keywordflow">if</span> (bus &gt;= <a class="code" href="group__types.html#ga14">BUS_COUNT</a>) {
00670         <span class="keywordflow">return</span> NULL;
00671     }
00672 
00673     <span class="keywordflow">return</span> bus_map[bus].<a class="code" href="structdiscover__bus__map.html#o0">name</a>;
00674 }
00675 
00681 <span class="keywordtype">char</span> *
<a name="l00682"></a><a class="code" href="group__conf.html#ga10">00682</a> <a class="code" href="group__conf.html#ga10">discover_conf_get_filetype_name</a>(<a class="code" href="group__types.html#ga17">discover_filetype_t</a> filetype)
00683 {
00684     <span class="keywordflow">if</span> (filetype &gt;= 3) {
00685         <span class="keywordflow">return</span> NULL;
00686     }
00687 
00688     <span class="keywordflow">return</span> filetype_map[filetype];
00689 }
00690 
00693 <span class="comment">/*</span>
00694 <span class="comment"> * Local variables:</span>
00695 <span class="comment"> * c-file-style: "progeny"</span>
00696 <span class="comment"> * indent-tabs-mode: nil</span>
00697 <span class="comment"> * End:</span>
00698 <span class="comment"> */</span>
00699 <span class="comment">/* vim: set cin fo=tcroq sw=4 et sts=4 tw=75: */</span>
</pre></div><hr size="1"><address style="align: right;"><small>Generated on Thu Jul 28 03:38:00 2005 for discover by&nbsp;
<a href="http://www.doxygen.org/index.html">
<img src="doxygen.png" alt="doxygen" align="middle" border="0"></a> 1.4.2 </small></address>
</body>
</html>
